﻿using System;

namespace MadMediaManager.Core.Domain.Attributes
{
    /// <summary>
    /// Facilitates indicating which property(s) describe the unique signature of an 
    /// entity.  <see cref="BaseEntity{TId}.GetTypeSpecificSignatureProperties()"/> for when this is leveraged.
    /// </summary>
    /// <remarks>
    /// This is intended for use with <see cref="BaseEntity{IdT}" />.
    /// </remarks>
    public class DomainSignatureAttribute : Attribute { }
}
