﻿using System.Collections.Generic;
using MadMediaManager.Core.Domain.Components;

namespace MadMediaManager.Core.Domain
{
    public class TelevisionIso : MovieIso
    {
        protected TelevisionIso()
        {
        }

        public new static TelevisionIso NewIso(string filePath, string name, long fileSize)
        {
            var iso = new TelevisionIso
            {
                EntityId = filePath,
                FileSize = new DigitalInformationUnitValue(DigitalInformationUnit.Byte, fileSize),
                IsFileFound = true,
                Name = name,
                _genres = new List<string>()
            };
            return iso;
        }

        public virtual string Season { get; set; }
        public virtual int DiscNumber { get; set; }
    }
}
