﻿using MadMediaManager.Core.Domain.Components;

namespace MadMediaManager.Core.Domain
{
    public class UnknownIso : Iso
    {
        protected UnknownIso()
        {
        }

        public static UnknownIso NewIso(string filePath, string name, long fileSize)
        {
            return new UnknownIso()
                       {
                           EntityId = filePath,
                           FileSize = new DigitalInformationUnitValue(DigitalInformationUnit.Byte, fileSize),
                           IsFileFound = true,
                           Name = name
                       };
        }

        public override IsoType IsoType
        {
            get { return IsoType.Unknown; }
            set { }
        }
    }
}
