﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MadMediaManager.Core.Interfaces.Domain
{
    /// <summary>
    /// Indicates if the entity is versionable in a data store
    /// </summary>
    public interface IVersionable<TVersion>
    {
        /// <summary>
        /// Indicates the current version of the object in the data store.
        /// </summary>
        TVersion RowVersion { get; set; }

        string VersionToString();
    }
}
