﻿using System.ComponentModel;

namespace MadMediaManager.Core.Interfaces.Services
{
    public interface IIsoMounter
    {
        /// <summary>
        /// Mounts the specified image to a virtaul drive
        /// </summary>
        /// <exception cref="Win32Exception">Thrown if the the underlying mounting API is not installed.</exception>
        /// <param name="filePath">The path to the image</param>
        void Mount(string filePath);

        /// <summary>
        /// Mounts the specified image to a virtaul drive
        /// </summary>
        /// <exception cref="Win32Exception">Thrown if the the underlying mounting API is not installed.</exception>
        /// <param name="filePath">The path to the image</param>
        void Unmount(string filePath);
    }
}
