﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace MadMediaManager.Views.Shell.Controls
{
    /// <summary>
    /// Interaction logic for MainMenuButton.xaml
    /// </summary>
    public class MainMenuButton : Button
    {
        public  static DependencyProperty ActiveRecordCountProperty = DependencyProperty.Register("ActiveRecordCount",
                                                                                           typeof(int),
                                                                                           typeof(MainMenuButton));
        public static DependencyProperty ImageProperty = DependencyProperty.Register("Image", typeof(ImageSource), typeof(MainMenuButton));
        public static DependencyProperty TitleProperty = DependencyProperty.Register("Title", typeof(string), typeof(MainMenuButton));

        public MainMenuButton()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(MainMenuButton),
                                                     new FrameworkPropertyMetadata(typeof(MainMenuButton)));
        }

        public int ActiveRecordCount
        {
            get { return (int)GetValue(ActiveRecordCountProperty); }
            set { SetValue(ActiveRecordCountProperty, value); }
        }

        public ImageSource Image
        {
            get { return GetValue(ImageProperty) as ImageSource; }
            set { SetValue(ImageProperty, value); }
        }

        public string Title
        {
            get { return GetValue(TitleProperty) as string; }
            set { SetValue(TitleProperty, value); }
        }
    }
}
