﻿using System;
using System.Windows.Input;
using MadMediaManager.WPFSupport;
using MadMediaManager.WPFSupport.Commands;
using MadMediaManager.WPFSupport.Interfaces.Services;
using MadMediaManager.WPFSupport.Services;
using Sanbox.Interfaces.Views;

namespace Sanbox.ViewModels
{
    public class MainViewModel : BaseViewModel
    {
        private IViewManager _viewManager;
        public MainViewModel(IViewManager viewManager)
        {
            _viewManager = viewManager;
            CreateCommands();
        }

        private void CreateCommands()
        {
            HomeCommand = new RelayCommand(o => _viewManager.TransitionToHome());
            AnotherCommand = new RelayCommand((o) => { return; });
        }

        public ICommand HomeCommand
        {
            get; private set;
        }

        public ICommand AnotherCommand
        {
            get;
            private set;
        }

        public override bool CanClose()
        {
            return true;
        }

        public override bool PropmtUserForClose()
        {
            return true;
        }
    }
}
